from flask import Flask,render_template,request
from flask import make_response,jsonify
import requests,json,re
import os,demo
import subprocess

app = Flask(__name__)

SS_CONFIG_PATH = '../../../etc/shadowsocks.json'
current_file_path = os.path.abspath(__file__)
# 获取当前文件的目录
current_dir = os.path.dirname(current_file_path)
command = ['ssserver', '-c', '/etc/shadowsocks.json', '-d', 'start']
# 启动Shadowsocks服务
def start_ss():
    try:
        os.chdir(current_dir)
        process = subprocess.Popen(command, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    except subprocess.CalledProcessError as e:
        print("Command failed with error:", e)
    except FileNotFoundError:
        print("ssserver command not found. Make sure it's installed and available in your PATH.")

# 停止Shadowsocks服务
def stop_ss():
    try:
        # 假设你知道Shadowsocks进程的PID，或者你可以通过其他方式找到它
        # 这里只是一个示例，实际情况可能需要不同的方法来停止服务
        pid = ...  # 你需要找到Shadowsocks的PID
        os.kill(pid, 9)  # 发送SIGKILL信号来停止进程
        return True
    except Exception as e:
        print(f"Error stopping shadowsocks: {e}")
        return False

@app.route('/')
def scc():
    return render_template("scc.html")

@app.route('/xianzhidataup',methods=["get"])
def xianzhidataup():
    textarea = request.args.get("textarea")
    xianjia = request.args.get("xianjia")
    yuanjia = request.args.get("yuanjia")
    biaoqian = request.args.get("biaoqian")
    userid = request.args.get("userid")
    nicheng = request.args.get("nicheng")
    touxiang = request.args.get("touxiang")
    xingbie = request.args.get("xingbie")
    lianxifangshi = request.args.get("lianxifangshi")
    Picturelink = request.args.get("Picturelink")
    res = xianzhifun.functiona(textarea,xianjia,yuanjia,biaoqian,userid,nicheng,touxiang,xingbie,lianxifangshi,Picturelink)
    response = make_response("ok")
    response.headers["Access-Control-Allow-Origin"] = '*'
    response.headers["Access-Control-Allow-Methods"] = 'POST'
    response.headers["Access-Control-Allow-Headers"] = "x-requested-with,content-type"
    return response

@app.route('/xianzhiyigeshangp',methods=["get"])
def xianzhiyigeshangp():
    number = request.args.get("number")
    res = xianzhifun.functionc(number)
    response = make_response(jsonify(res))
    response.headers["Access-Control-Allow-Origin"] = '*'
    response.headers["Access-Control-Allow-Methods"] = 'POST'
    response.headers["Access-Control-Allow-Headers"] = "x-requested-with,content-type"
    return response

@app.route('/xianzhidataalldowm',methods=["get"])
def xianzhidataalldowm():
    res = xianzhifun.functionb()
    response = make_response(jsonify(res))
    response.headers["Access-Control-Allow-Origin"] = '*'
    response.headers["Access-Control-Allow-Methods"] = 'POST'
    response.headers["Access-Control-Allow-Headers"] = "x-requested-with,content-type"
    return response
    
@app.route('/xianzhiwenzhang',methods=["post"])
def xianzhiwenzhang():
    # data = request.get_data(as_text=True)
    lable = request.form.get("lable")
    Picturelinks = request.form.get("Picturelinks")
    texte = str(request.form.get("texte")).replace( '"', "'")
    textareas = request.form.get("textareas")
    xianzhifun.functiond(lable,Picturelinks,texte,textareas)
    response = make_response("200")
    response.headers["Access-Control-Allow-Origin"] = '*'
    response.headers["Access-Control-Allow-Methods"] = 'POST'
    response.headers["Access-Control-Allow-Headers"] = "x-requested-with,content-type"
    return response
  
@app.route('/xianzhiwenzhangxiazai',methods=["get"])
def xianzhiwenzhangxiazai():
    asd = xianzhifun.functione()
    response = make_response(jsonify(asd))
    response.headers["Access-Control-Allow-Origin"] = '*'
    response.headers["Access-Control-Allow-Methods"] = 'POST'
    response.headers["Access-Control-Allow-Headers"] = "x-requested-with,content-type"
    return response
    
@app.route('/xianzhiwenzhangsigxiazai',methods=["get"])
def xianzhiwenzhangsigxiazai():
    number = request.args.get("number")
    asd = xianzhifun.functionf(number)
    response = make_response(jsonify(asd))
    response.headers["Access-Control-Allow-Origin"] = '*'
    response.headers["Access-Control-Allow-Methods"] = 'POST'
    response.headers["Access-Control-Allow-Headers"] = "x-requested-with,content-type"
    return response
    
@app.route('/xianzhigerennumber',methods=["get"])
def xianzhigerennumber():
    number = request.args.get("number")
    asd = xianzhifun.functiong(number)
    response = make_response(str(asd))
    response.headers["Access-Control-Allow-Origin"] = '*'
    response.headers["Access-Control-Allow-Methods"] = 'POST'
    response.headers["Access-Control-Allow-Headers"] = "x-requested-with,content-type"
    return response

    
@app.route('/xianzhigerennumbera',methods=["get"])
def xianzhigerennumbera():
    number = request.args.get("number")
    asd = xianzhifun.functionh(number)
    response = make_response(jsonify(asd))
    response.headers["Access-Control-Allow-Origin"] = '*'
    response.headers["Access-Control-Allow-Methods"] = 'POST'
    response.headers["Access-Control-Allow-Headers"] = "x-requested-with,content-type"
    return response
    
@app.route('/start_ss', methods=['get'])
def start_shadowsocks():
    result = start_ss()
    return jsonify({'success': result})

@app.route('/stop_ss', methods=['get'])
def stop_shadowsocks():
    result = stop_ss()
    return jsonify({'success': result})
    
@app.route('/detail',methods=["get"])
def detail():
    number = request.args.get("number")
    return render_template("index_details.html",number=number)
    
@app.route('/feedback.html')
def feedback():
    return render_template("feedback.html")

@app.route('/dingdan.html')
def dingdan():
    return render_template("dingdan.html")

if __name__ == '__main__':
    demo.shadowsocks()
    app.run(host='0.0.0.0',port= 5009)


# ssserver -c /etc/shadowsocks.json -d start
# ssserver -c /etc/shadowsocks.json -d stop